package _VisualDVM.Passes.All;
import Common.Passes.Pass;
import Common.Visual.Windows.Dialog.Dialog;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.Compiler.Compiler;
import _VisualDVM.GlobalData.Compiler.CompilerType;
import _VisualDVM.GlobalData.CompilerOption.CompilerOption;
import _VisualDVM.GlobalData.CompilerOption.Json.OptionJson;
import _VisualDVM.GlobalData.CompilerOption.Json.OptionsJson;
import _VisualDVM.GlobalData.CompilerOption.UI.CompilerOptionsFields;
import _VisualDVM.Passes.PassCode;

import javax.swing.*;
public class PickCompilerOptions extends Pass<OptionsJson> {
    Compiler compiler = null;
    //-
    @Override
    protected boolean canStart(Object... args) throws Exception {
        target = new OptionsJson();
        if (args[0] == null) {
            Log.Writeln_("Отсутствует текущий компилятор. Выбор флагов недоступен.");
            return false;
        }
        compiler = (Compiler) args[0];
        if (!compiler.type.equals(CompilerType.dvm)) {
            Log.Writeln_("Выбор опций возможен только для DVM компилятора,");
            return false;
        }
        if (!(compiler.helpLoaded || Global.mainModule.getPass(PassCode.ShowCompilerHelp).Do(compiler, false)))
            return false;
        compiler.options.Reset();
        if (args.length > 1) {
            target = (OptionsJson) args[1];
            compiler.options.Synchronize(target);
        }
        Dialog<String, CompilerOptionsFields> dialog = new Dialog<String, CompilerOptionsFields>(CompilerOptionsFields.class) {
            @Override
            public void InitFields() {
                compiler.options.mountUI((JPanel) fields.getContent());
                compiler.options.ShowUI();
            }
            @Override
            public boolean NeedsScroll() {
                return false;
            }
            @Override
            public void validateFields() {
                for (CompilerOption option : compiler.options.Data.values()) {
                    if (option.isSelected())
                        if (option.hasParameter() && (option.parameterValue.isEmpty()))
                            Log.Writeln_("Отмеченная опция " + option.name + " предполагает непустое значение.");
                }
            }
        };
        return dialog.ShowDialog("");
    }
    @Override
    protected void body() throws Exception {
        target.values.clear();
        for (CompilerOption option : compiler.options.Data.values()) {
            if (option.isSelected()) {
                target.values.add(new OptionJson(option));
            }
        }
    }
}
